/** Rill v0.0.493 https://www.npmjs.com/package/rill License: MIT*/
var Request, expect, parseURL;

parseURL = require("parse-url");

expect = require("./util/expect");


/*
 * Constructor that will normalize a request object.
#
 * @param {Object} req
 * @constructor
 */

Request = (function() {
  function Request(req) {
    var defaults, key, ref, ref1, ref2, ref3, ref4, ref5, ref6, ref7, val;
    if (!(this instanceof Request)) {
      return new Request(req);
    }
    expect(req != null, "Could not create Request with an empty object.");
    expect(req.url != null, "Could not create a Request without a URL.");
    this.originalReq = req;
    this.headers = (ref = req.headers) != null ? ref : {};
    this.method = (ref1 = req.method) != null ? ref1 : "GET";
    {
      this.ip = (ref2 = (ref3 = this.headers["x-forwarded-for"]) != null ? ref3.split(",")[0] : void 0) != null ? ref2 : (ref4 = req.connection) != null ? ref4.remoteAddress : void 0;
      this.referrer = this.headers["referrer"];
      ref5 = (this.headers["x-forwarded-host"] || this.headers["host"] || "").split(":"), this.hostname = ref5[0], this.port = ref5[1];
      this.protocol = ((ref6 = req.socket) != null ? ref6.encrypted : void 0) ? "https:" : "http:";
      defaults = this;
    }
    ref7 = parseURL(req.url, defaults);
    for (key in ref7) {
      val = ref7[key];
      this[key] = val;
    }
  }


  /*
  	 * Trigger another request that will redirect the browser and send a location change on the server.
  	 * If "back" is the url then it will attempt to redirect the user back a url, otherwise the alt will be used.
  	#
  	 * @param {String} url
  	 * @param {String} alt
   */

  Request.prototype.redirect = function(url, alt) {
    if (url == null) {
      url = "back";
    }
    if (alt == null) {
      alt = "/";
    }
    if (url === "back") {
      url = this.referrer || alt;
    }
    return this.redirectURL = url;
  };

  return Request;

})();

module.exports = Request;
